unit Unit1;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFDEF FPC}
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls,
  DB, BufDataset, DBGrids;
{$ELSE}
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs,
  Data.DB, Datasnap.DBClient, Vcl.Grids, Vcl.DBGrids, Vcl.StdCtrls;
{$ENDIF}


type
  TForm1 = class(TForm)
    DataSource: TDataSource;
    DBGrid1: TDBGrid;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private-Deklarationen }
  {$IFDEF FPC}
    Dataset: TBufDataset;
  {$ELSE}
    DataSet: TClientDataset;
  {$ENDIF}
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$IFDEF FPC}
  {$R *.lfm}
{$ELSE}
  {$R *.dfm}
{$ENDIF}

procedure TForm1.Button1Click(Sender: TObject);
begin
  Dataset.Filtered := false;
  Dataset.Filter := 'Value IS NULL';
  Dataset.Filtered := true;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Dataset.Filtered := false;
  Dataset.Filter := 'NOT Value IS NULL';
  Dataset.Filtered := true;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Dataset.Filtered := false;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  i: Integer;
  F: TField;
begin
{$IFDEF FPC}
  Dataset := TBufDataset.Create(self);
{$ELSE}
  Dataset := TClientDataset.Create(self);
{$ENDIF}
  Datasource.Dataset := Dataset;

  Dataset.FieldDefs.Add('Value', ftInteger);
  Dataset.CreateDataset;
  Dataset.Open;
  F := Dataset.FieldByName('Value');

  for i := 0 to 1000 do
  begin
    Dataset.Append;
    if Random(5) < 2 then
      F.Value := null
    else
      F.AsInteger := Random(100);
    Dataset.Post;
  end;
end;

end.
